Index: fact/tools/rootmacros/PulseTemplates/pixel.C
===================================================================
--- fact/tools/rootmacros/PulseTemplates/pixel.C	(revision 13544)
+++ fact/tools/rootmacros/PulseTemplates/pixel.C	(revision 13559)
@@ -97,4 +97,5 @@
     if (mVerbosityLevel > 2) cout << endl << "...book pixel histograms" << endl;
     TString histo_name;
+    TString histo_title;
 
     for (int order = 0; order < mMaxPulseOrder; order++)
@@ -104,8 +105,15 @@
         histo_name +=   "_";
         histo_name +=   order;
+
+        histo_title =   "Overlay of detected pulses of one pulse order for one Pixel ";
+        histo_title +=   "[Pixel_Order] ";
+        histo_title +=  mChid;
+        histo_title +=   "_";
+        histo_title +=   order;
+
         if (mVerbosityLevel > 3) cout << "\t...booking " << histo_name << endl;
         hMaxOverlay[order]=new TH2F(
                 histo_name,
-                "Overlay of detected pulses of one pulse order for one Pixel",
+                histo_title,
                 mPixelOverlayXaxisLeft + mPixelOverlayXaxisRight ,
                 (-1*mPixelOverlayXaxisLeft)-0.5,
@@ -145,8 +153,15 @@
         histo_name +=   "_";
         histo_name +=   order;
+
+        histo_title =   "Overlay at rising edge of detected pulses of one pulse order for one Pixel ";
+        histo_title +=   "[Pixel_Order] ";
+        histo_title +=  mChid;
+        histo_title +=   "_";
+        histo_title +=   order;
+
         if (mVerbosityLevel > 3) cout << "\t...booking " << histo_name << endl;
         hEdgeOverlay[order] = new TH2F(
                     histo_name,
-                    "Overlay at rising edge of detected pulses of one pulse order for one Pixel ",
+                    histo_title,
                     mPixelOverlayXaxisLeft + mPixelOverlayXaxisRight ,
                     (-1*mPixelOverlayXaxisLeft)-0.5,
@@ -178,8 +193,15 @@
         histo_name +=   "_";
         histo_name +=   order;
+
+        histo_title =   "Mean value of each slice in overlay plot (Tprofile) ";
+        histo_title +=   "[Pixel_Order] ";
+        histo_title +=  mChid;
+        histo_title +=   "_";
+        histo_title +=   order;
+
         if (mVerbosityLevel > 3) cout << "\t...booking " << histo_name << endl;
         hMaxProfile[order] = new TProfile(
                     histo_name,
-                    "Mean value of each slice in overlay plot (Tprofile)",
+                    histo_title,
                     mPixelOverlayXaxisLeft + mPixelOverlayXaxisRight ,//nbinsx
                     (-1*mPixelOverlayXaxisLeft)-0.5,                 //xlow
@@ -212,8 +234,15 @@
         histo_name +=   "_";
         histo_name += order;
+
+        histo_title =   "Mean value of each slice in overlay plot (Tprofile) ";
+        histo_title +=   "[Pixel_Order] ";
+        histo_title +=  mChid;
+        histo_title +=   "_";
+        histo_title +=   order;
+
         if (mVerbosityLevel > 3) cout << "\t...booking " << histo_name << endl;
         hEdgeProfile[order] = new TProfile(
                     histo_name,
-                    "Mean value of each slice in overlay plot (Tprofile)",
+                    histo_title,
                     mPixelOverlayXaxisLeft + mPixelOverlayXaxisRight ,//nbinsx
                     (-1*mPixelOverlayXaxisLeft)-0.5,                 //xlow
@@ -242,5 +271,5 @@
 void
 Pixel::DrawHistograms(
-        TCanvas*    pixelCanvas,
+        TCanvas**    pixelCanvas,
         int*        histoFrameNr
         )
@@ -249,11 +278,11 @@
     for (int pulse_order = 0; pulse_order < mMaxPulseOrder; pulse_order++)
     {
-        pixelCanvas[pulse_order].cd( histoFrameNr[0] );
+        pixelCanvas[pulse_order]->cd( histoFrameNr[0] );
         hMaxOverlay[pulse_order]->Draw("COLZ");
-        pixelCanvas[pulse_order].cd( histoFrameNr[2] );
-        hMaxProfile[pulse_order]->Draw("COLZ");
+        pixelCanvas[pulse_order]->cd( histoFrameNr[2] );
+        hMaxProfile[pulse_order]->Draw();
         hEdgeProfile[pulse_order]->Draw("SAME");
 
-        pixelCanvas[pulse_order].cd( histoFrameNr[1] );
+        pixelCanvas[pulse_order]->cd( histoFrameNr[1] );
         hEdgeOverlay[pulse_order]->Draw("COLZ");
     }
@@ -269,4 +298,5 @@
     {
         TString histo_name;
+        TString histo_title;
         for (int order =0; order < mMaxPulseOrder; order++)
         {
@@ -281,8 +311,12 @@
                 histo_name +=   "_";
                 histo_name +=   order;
+                histo_title =   "Distribution of rising edge [Pixel_Order]";
+                histo_title +=  mChid;
+                histo_title +=   "_";
+                histo_title +=   order;
                 if (mVerbosityLevel > 3) cout << "\t...booking " << histo_name << endl;
                 hSlopeRisingEdge[order] = new TH1F (
                             histo_name,
-                            "Distribution of rising edge",
+                            histo_title,
                             600,
                             -10.1,
@@ -300,8 +334,12 @@
                 histo_name +=   "_";
                 histo_name +=    order;
+                histo_title =   "Deviation of rising edge and maximum [Pixel_Order]";
+                histo_title +=  mChid;
+                histo_title +=   "_";
+                histo_title +=   order;
                 if (mVerbosityLevel > 3) cout << "\t...booking " << histo_name << endl;
                 hRisingEdgeToMax[order] = new TH1F (
                             histo_name,
-                            "Deviation of rising edge and maximum",
+                            histo_title,
                             600,
                             -10.1,
@@ -319,8 +357,12 @@
                 histo_name +=   "_";
                 histo_name +=   order;
+                histo_title =   "Deviation of rising edge and maximum [Pixel_Order]";
+                histo_title +=  mChid;
+                histo_title +=   "_";
+                histo_title +=   order;
                 if (mVerbosityLevel > 3) cout << "\t...booking " << histo_name << endl;
                 hPosOfMax[order] = new TH1F (
                             histo_name,
-                            "Deviation of rising edge and maximum",
+                            histo_title,
                             600,
                             -10.1,
@@ -339,5 +381,5 @@
 void
 Pixel::DrawDistributionHistograms(
-        TCanvas*    pixelCanvas,
+        TCanvas**    pixelCanvas,
         int*        histoFrameNr
         )
@@ -346,10 +388,10 @@
     for (int pulse_order = 0; pulse_order < mMaxPulseOrder; pulse_order++)
     {
-        pixelCanvas[pulse_order].cd( histoFrameNr[0] );
+        pixelCanvas[pulse_order]->cd( histoFrameNr[0] );
         hSlopeRisingEdge[pulse_order]->Draw();
-        pixelCanvas[pulse_order].cd( histoFrameNr[1] );
+        pixelCanvas[pulse_order]->cd( histoFrameNr[1] );
         hRisingEdgeToMax[pulse_order]->Draw();
 
-        pixelCanvas[pulse_order].cd( histoFrameNr[2] );
+        pixelCanvas[pulse_order]->cd( histoFrameNr[2] );
         hPosOfMax[pulse_order]->Draw();
     }