Index: fact/tools/rootmacros/PulseTemplates/pixel.C
===================================================================
--- fact/tools/rootmacros/PulseTemplates/pixel.C	(revision 13581)
+++ fact/tools/rootmacros/PulseTemplates/pixel.C	(revision 13583)
@@ -55,10 +55,10 @@
     if (mOptions.Contains("R") )
     {
-        hRisingEdgeToMax = new TH1F*[mMaxPulseOrder];
+        hRisingEdgeToMax = new TH1I*[mMaxPulseOrder];
     }
 
     if (mOptions.Contains("M") )
     {
-        hPosOfMax = new TH1F*[mMaxPulseOrder];
+        hPosOfMax = new TH1I*[mMaxPulseOrder];
     }
 
@@ -297,6 +297,9 @@
     if (!mOptions.IsNull() )
     {
+        int x_min = 0;
+        int x_max = 0;
         TString histo_name;
         TString histo_title;
+
         for (int order =0; order < mMaxPulseOrder; order++)
         {
@@ -307,9 +310,10 @@
             if (mOptions.Contains("S"))
             {
+
                 histo_name =    "hSlopeRisingEdge";
                 histo_name +=   mChid;
                 histo_name +=   "_";
                 histo_name +=   order;
-                histo_title =   "Distribution of rising edge [Pixel_Order]";
+                histo_title =   "Distribution of rising edge's slope [Pixel_Order] ";
                 histo_title +=  mChid;
                 histo_title +=   "_";
@@ -323,5 +327,5 @@
                             10.1
                             );
-                hSlopeRisingEdge[order]->GetXaxis()->SetTitle( "Timeslices [a.u.]" );
+                hSlopeRisingEdge[order]->GetXaxis()->SetTitle( "Slope Amplitude/time [mV/timeslices]" );
                 hSlopeRisingEdge[order]->GetYaxis()->SetTitle( "counts" );
                 hList->Add( hSlopeRisingEdge[order] );
@@ -330,19 +334,22 @@
             if (mOptions.Contains("R"))
             {
+                x_min = -15;
+                x_max = 35;
+
                 histo_name =    "hRisingEdgeToMax";
                 histo_name +=   mChid;
                 histo_name +=   "_";
                 histo_name +=    order;
-                histo_title =   "Deviation of rising edge and maximum [Pixel_Order]";
+                histo_title =   "Distance from rising edge to pulse's maximum [Pixel_Order] ";
                 histo_title +=  mChid;
                 histo_title +=   "_";
                 histo_title +=   order;
                 if (mVerbosityLevel > 3) cout << "\t...booking " << histo_name << endl;
-                hRisingEdgeToMax[order] = new TH1F (
+                hRisingEdgeToMax[order] = new TH1I (
                             histo_name,
                             histo_title,
-                            600,
-                            -10.1,
-                            10.1
+                            x_max -x_min,
+                            x_min,
+                            x_max
                             );
                 hRisingEdgeToMax[order]->GetXaxis()->SetTitle( "Timeslices [a.u.]" );
@@ -353,19 +360,22 @@
             if (mOptions.Contains("M"))
             {
+                x_min = 10;
+                x_max = 290;
+
                 histo_name =    "hPosOfMax";
                 histo_name +=   mChid;
                 histo_name +=   "_";
                 histo_name +=   order;
-                histo_title =   "Deviation of rising edge and maximum [Pixel_Order]";
+                histo_title =   "Distribution of pulse's maximum's positon [Pixel_Order] ";
                 histo_title +=  mChid;
                 histo_title +=   "_";
                 histo_title +=   order;
                 if (mVerbosityLevel > 3) cout << "\t...booking " << histo_name << endl;
-                hPosOfMax[order] = new TH1F (
+                hPosOfMax[order] = new TH1I (
                             histo_name,
                             histo_title,
-                            600,
-                            -10.1,
-                            10.1
+                            x_max - x_min,
+                            x_min,
+                            x_max
                             );
                 hPosOfMax[order]->GetXaxis()->SetTitle( "Timeslices [a.u.]" );