Index: fact/tools/rootmacros/PulseTemplates/FPulseOverlay.C
===================================================================
--- fact/tools/rootmacros/PulseTemplates/FPulseOverlay.C	(revision 13595)
+++ fact/tools/rootmacros/PulseTemplates/FPulseOverlay.C	(revision 13598)
@@ -180,5 +180,5 @@
 void ProduceDebugHistos( vector<Region> *pZXings);
 bool  UseThisPulse( int, int, int, int, int, int);
-void UpdateCanvases( int, int);
+void UpdateCanvases( int, int, bool);
 void DeletePixelCanvases( int, int );
 
@@ -196,8 +196,8 @@
         bool            debugPixel          = true,
         bool            testmode            = false,
-        bool            saveResults         = false,
+        bool            saveResults         = true,
         int             verbosityLevel      = 1,        // different verbosity levels can be implemented here
         int             firstevent          = 1,        // Hast to be between 1 and infinity NOT 0!!!!
-        int             nevents             = 10000,
+        int             nevents             = 100,
         int             firstpixel          = 15,
         int             npixel              = 3,
@@ -278,5 +278,5 @@
             cTitle   ="Distributions of Pulses with Order of: ";
             cTitle   += pulse_order;
-            cgpDistributions[pulse_order] = new TCanvas(cName,cTitle, 0,pulse_order*20,800,800);
+            cgpDistributions[pulse_order] = new TCanvas(cName,cTitle, 720,pulse_order*20,720,720);
             cgpDistributions[pulse_order]->Divide(2, 2);
             cName   ="cgpPixelPulses";
@@ -284,5 +284,5 @@
             cTitle   ="Overlays of Pulses with Order of: ";
             cTitle   += pulse_order;
-            cgpPixelPulses[pulse_order] = new TCanvas(cName,cTitle, 0,pulse_order*20,800,800);
+            cgpPixelPulses[pulse_order] = new TCanvas(cName,cTitle, 0,pulse_order*20,720,720);
             cgpPixelPulses[pulse_order]->Divide(2, 2);
         }
@@ -295,11 +295,14 @@
         if (spikeDebug)
         {
-          cFiltered = new TCanvas("cFiltered","filtered DRS Waveforms", 1,310,400,300);
+          cFiltered = new TCanvas("cFiltered","filtered DRS Waveforms", 1080,420,360,360);
           cFiltered->Divide(1, 3);
         }
 
+        if (testmode)
+        {
         //additional Test histograms
-        cgpTestHistos = new TCanvas( "cgpTestHistos", "Test Histograms", 801, 0, 800, 800 );
+        cgpTestHistos = new TCanvas( "cgpTestHistos", "Test Histograms", 360, 420, 360, 360 );
         cgpTestHistos->Divide(2,0);
+        }
     }
 
@@ -600,5 +603,6 @@
                             UpdateCanvases(
                                         verbosityLevel,
-                                        maxPulseOrder
+                                        maxPulseOrder,
+                                        testmode
                                         );
                         }
@@ -649,6 +653,7 @@
 
                 UpdateCanvases(
-                               verbosityLevel,
-                               maxPulseOrder
+                            verbosityLevel,
+                            maxPulseOrder,
+                            testmode
                                );
             }
@@ -709,5 +714,6 @@
         UpdateCanvases(
                     verbosityLevel,
-                    maxPulseOrder
+                    maxPulseOrder,
+                    testmode
                     );
 
@@ -723,5 +729,7 @@
                     verbosityLevel
                     );
-        delete      cgpTestHistos;
+
+        if (testmode)
+            delete      cgpTestHistos;
 
         if (spikeDebug)
@@ -976,5 +984,6 @@
 UpdateCanvases(
         int verbosityLevel,
-        int max_pulse_order
+        int max_pulse_order,
+        bool testmode
         )
 {
@@ -986,6 +995,9 @@
         cgpDistributions[pulse_order]->Modified();
         cgpDistributions[pulse_order]->Update();
-        cgpTestHistos->Modified();
-        cgpTestHistos->Update();
+        if ( testmode )
+        {
+            cgpTestHistos->Modified();
+            cgpTestHistos->Update();
+        }
     }
 }